def deploymentsMap = [
    "master" : 8080
    , "main" : 8080
    , "develop" : 8081
    , "feature" : 8082
]

def branchRoot = BRANCH_NAME.split('/')[0]
def deployToPort = deploymentsMap[branchRoot]
def dockerTag = "latest"

pipeline {
    agent any

    options {
        timestamps()
        disableConcurrentBuilds()
        parallelsAlwaysFailFast()
        ansiColor('xterm')
    }

    stages {
        stage('build docker') {
            steps {
                script {
                    println "build docker"
                    sh "cd website && whoami && docker build -t counter-service:${dockerTag} ."
                }
            }
        }
        stage('test earlier deployed docker') {
            steps {
                script {
                    println "get counter for earlier docker"
                    try {
                        sh "curl -s http://ec2-18-194-117-172.eu-central-1.compute.amazonaws.com:${deployToPort}/counter-service"
                    }
                    catch (all) {
                        
                    }
                }
            }
        }
        stage('remove earlier deployed docker') {
            steps {
                script {
                    println "remove earlier docker"
                    try {
                        sh "docker rm -f counter-${branchRoot}"
                    }
                    catch(all) {

                    }
                }
            }
        }
        stage('deploy docker') {
            steps {
                script {
                    println "deploy docker"
                    sh "docker run --publish ${deployToPort}:80 --restart=always --detach --name counter-${branchRoot} counter-service:${dockerTag} "
                }
            }
        }
        stage('test recent docker') {
            steps {
                script {
                    println "get counter for recent docker (should be zero)"
                    sh "curl -s http://ec2-18-194-117-172.eu-central-1.compute.amazonaws.com:${deployToPort}/counter-service"
                }
            }
        }
    }
}
